from termcolor import colored # type: ignore
from migen import * # type: ignore
from litex.soc.interconnect.stream import Endpoint # type: ignore
from migen.fhdl.structure import _Assign # type: ignore
from typing import List, Optional, Union, Callable, Tuple
import logging
import datetime
#from monitor import MonitoringComponentSender
import os
from migen.fhdl.structure import _Operator, _Statement, _Value

Layout = List[Tuple[str, int]] # Type annotation for a migen component layout
MigenValue = Union[Signal, _Value, _Statement, _Operator]
MigenValueList = [Signal, _Value, _Statement, _Operator]


OUTPUT_FOLDER = "build_data"

try:
    lbm_logger = logging.getLogger("lbm_logger")
    lbm_logger.addHandler(logging.FileHandler(os.path.join(OUTPUT_FOLDER, "lbm_build_log.log"), mode="w+"))
    lbm_logger.setLevel(logging.DEBUG)
    lbm_logger.propagate = False
except FileNotFoundError:
    lbm_logger = logging.getLogger("lbm_logger")
    lbm_logger.addHandler(logging.FileHandler(os.path.join(os.getcwd(), "lbm_build_log.log"), mode="w+"))
    lbm_logger.setLevel(logging.DEBUG)
    lbm_logger.propagate = False


def say(s : str, error : bool = False, log : bool = True) -> None:
    """Print the given string with green or red color. Also logs the string using the global logger

    Args:
        s (str): String to be printed
        error (bool, optional): When true print red, else green. Defaults to False.
        log (bool, optional): Whether or not to log the string as well. Defaults to True.
    """
    global lbm_logger
    print(colored(s, ('green' if not error else "red")))
    if log:
        lbm_logger.debug(s)


def simple_connect(a : Endpoint, b : Endpoint, aSourceReady : Optional[Signal] = None, bSinkValid : Optional[Signal] = None, dataInput : Optional[Signal] = None) -> List[_Assign]:
    """Return a list of migen assignments for connection of two stream elements.

    Args:
        a (Endpoint): Origin Endpoint
        b (Endpoint): Target Endpoint
        aSourceReady (Optional[Signal], optional): Alternative to a.source.ready. Defaults to None.
        bSinkValid (Optional[Signal], optional): .... Defaults to None.
        dataInput (Optional[Signal], optional): Alternative to a.source.data. Defaults to None.

    Returns:
        List[_Assign]: The assignments. To be added to self.comb 
    """
    return [
        a.source.ready.eq(b.sink.ready if aSourceReady is None else aSourceReady),
        b.sink.valid.eq(a.source.valid if bSinkValid is None else bSinkValid),
        (b.sink.data.eq(a.source.data) if dataInput is None else (b.sink.data.eq(dataInput)))
    ]

def write_c_headers_sources(recorder : "MonitoringComponentSender", HEADER_PATH : str, SOURCE_PATH : str, numEntries : int, startingAddress : Optional[int] = None) -> None:
    """Writes necessary build information into c header and source files for the firmware to include

    Args:
        recorder (MonitoringComponentSender): The Recorder component. Needed for layout infos, bit widths, etc.
        HEADER_PATH (str): Absolute path to the header location
        SOURCE_PATH (str): Absolute path to the source location
        numEntries (int): 
        startingAddress (Optional[int], optional): TODO FIX. Defaults to None.
    """
    say("[BUS MONITOR COMPONENT] Writing C headers and sources")
    say(f"[BUS MONITOR COMPONENT] Header File Path: {HEADER_PATH}")
    if os.path.isdir(os.path.dirname(HEADER_PATH)):
        with open(HEADER_PATH, 'w+') as f:
            f.write(f"// Automatically generated by the MonitoringComponent during SoC Building at {str(datetime.datetime.now())}\n")
            f.write(f"#ifndef PREDEFINED_H\n#define PREDEFINED_H\n\n")
            f.write(f"#define BITS_PER_ENTRY {recorder.bitsPerEntry}\n")
            f.write(f"#define NUM_ENTRIES {numEntries}\n")
            f.write(f"#define NUM_TRACES {len(recorder.recorder.outLayout)}\n")
            f.write(f"#define ARRAY_ELEMENTS {recorder.wordsNeeded}\n")
            if startingAddress is not None:
                f.write(f"#define HAS_FIXED_DMA_ADDRESS\n")
                f.write(f"#define DMA_STARTING_ADDRESS {startingAddress}\n")
                f.write(f"extern volatile unsigned long * fifoContents;\n")
            else:
                f.write(f"extern volatile unsigned long fifoContents[{recorder.wordsNeeded}];\n")
            f.write(f"\nextern char *traceNames[{len(recorder.recorder.outLayout)}];\n")
            f.write(f"extern int traceBitLengths[{len(recorder.recorder.outLayout)}];\n")
            
            f.write("\n#endif\n")
    else:
        say("[MONITOR COMPONENT] Path for header file is invalid (wrong directory? Need to be in the gen.py / soc.py directory). Continuing anyways", error=True)

    say(f"[BUS MONITOR COMPONENT] Source File Path: {SOURCE_PATH}")
    if os.path.isdir(os.path.dirname(SOURCE_PATH)):
        with open(SOURCE_PATH, 'w+') as f:
            f.write(f"// Automatically generated by the MonitoringComponent during SoC Building at {str(datetime.datetime.now())}\n")
            f.write(f"\n#include \"predefined.h\"\n")
            f.write(f"char *traceNames[{len(recorder.recorder.outLayout)}] = {{\n")
            for n,_ in recorder.recorder.outLayout:
                f.write(f"\t\"{n}\",\n")
            f.write("};\n")
            f.write(f"int traceBitLengths[{len(recorder.recorder.outLayout)}] = {{\n")
            for _,l in recorder.recorder.outLayout:
                f.write(f"\t{l},\n")
            f.write("};\n")
            if startingAddress is None:
                f.write(f"volatile unsigned long fifoContents[{recorder.wordsNeeded}] = {{0}};\n")
            else:
                f.write(f"volatile unsigned long * fifoContents = (unsigned long *) DMA_STARTING_ADDRESS;\n")
    else:
        say("[MONITOR COMPONENT] Path for source file is invalid (wrong directory? Need to be in the gen.py / soc.py directory). Continuing anyways", error=True)
